Attribute VB_Name = "modUtil"
Option Explicit

Private Declare Function QueryPerformanceCounter Lib "kernel32" (lpPerformanceCount As Currency) As Long
Private Declare Function QueryPerformanceFrequency Lib "kernel32" (lpFrequency As Currency) As Long

Dim QF As Currency
Dim OldQC As Currency
Dim MinCur As Currency
Dim MaxCur As Currency
Dim QTimeVal As Double

Dim Ar() As Long
Const Max As Long = 9999999

Sub Main()
  Dim i As Long
  Dim t1 As Double
  Dim t2 As Double
  Dim t3 As Double

  ReDim Ar(Max)

  For i = 0 To Max
    Ar(i) = (Rnd - 0.5) * 65536
  Next i
  QTimeReset 0
  For i = 0 To Max
    Ar(i) = ClampIf(Ar(i))
  Next i
  t1 = QTime

  For i = 0 To Max
    Ar(i) = (Rnd - 0.5) * 65536
  Next i
  QTimeReset 0
  For i = 0 To Max
    Ar(i) = ClampMath(Ar(i))
  Next i
  t2 = QTime

  For i = 0 To Max
    Ar(i) = (Rnd - 0.5) * 65536
  Next i
  QTimeReset 0
  For i = 0 To Max
    Ar(i) = ClampLogic(Ar(i))
  Next i
  t3 = QTime

  MsgBox "If: " & Format(t1, "0.######") & Chr(10) & Chr(13) & _
       "Math: " & Format(t2, "0.######") & Chr(10) & Chr(13) & _
      "Logic: " & Format(t3, "0.######") '& Chr(10) & Chr(13)
End Sub

Private Function ClampIf(ByVal r As Long) As Long
  If r > 255 Then r = 255 Else If r < 0 Then r = 0
  ClampIf = r
End Function

Private Function ClampMath(ByVal r As Long) As Long
  r = (r > 255) * (r - 255) - r * (r > 0)
  ClampMath = r
End Function

Private Function ClampLogic(ByVal r As Long) As Long
  r = (r And (r > 0)) - ((r - 255) And (r > 255))
  ClampLogic = r
End Function

Private Sub QTimeReset(ByVal Time As Double)
  MaxCur = CCur("922337203685477") + CCur(0.5807)
  MinCur = -MaxCur - CCur(0.0001)
  QueryPerformanceCounter OldQC
  QueryPerformanceFrequency QF
  QTimeVal = Time
End Sub

Private Function QTime() As Double
  Dim QC As Currency

  QueryPerformanceCounter QC
  If QC >= OldQC Then
    QTimeVal = QTimeVal + (QC - OldQC) / QF
  Else
    QTimeVal = QTimeVal + ((MaxCur - OldQC) + (QC - MinCur)) / QF
  End If
  OldQC = QC
  QTime = QTimeVal
End Function
